/** 
 *   Ejemplo para VAC...
 *
 *
 *   (c) Copyright 2006 Federico Bareilles <fede@iar.unlp.edu.ar>,
 *   Instituto Argentino de Radio Astronomia (IAR).
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the License, or (at your option) any later version.
 *     
 *   The author does NOT admit liability nor provide warranty for any
 *   of this software. This material is provided "AS-IS" in the hope
 *   that it may be useful for others.
 *
 **/
#define _POSIX_SOURCE 1

#ifndef _VAC_H
#define _VAC_H

#include <stdio.h>
#include <stdint.h>
#include <limits.h>
#include <termios.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <time.h>
#include <getopt.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>

#include "my_stdio.h"
#include "parse_tools.h"

#include "parse_tools.h"

#define BUFF 256

#define BAUDRATE B2400

#define CR 0x0D        // Carriage Return
#define LF 0x0A        // Line Feed
#define ACK 0x06
#define NAK 0x15


struct vac {
        int fd;
        char *name;
        char *device;
        int sensor_n;
        char **sensor;
	struct vac *next;
};

// FUNCTION PROTOTYPES
int free_vac(struct vac *v);
int get_readings (struct vac *vac_conf, double *readings);
int vac_init(struct vac **vac_conf);
int vac_close (struct vac *vac_conf);
int count_sensors (struct vac *vac_conf);
unsigned long get_interval (struct configuration *conf);
int vac_read (int fd, char *recv);
int check_ack (int fd);
int sensor_get (int fd, char *sensor, double *value, char *units);

/**
 * if vac_conf is NULL make_vac_from_conf() allocate this. if not
 * NULL, free it via free_vac(), and allocate again.
 *
 * RETURN VALUE: Number of find instrumenets definitions in conf.
**/
int make_vac_from_conf(struct vac **vac_conf, struct configuration *conf);

#endif /* _VAC_H */
